// Use https://kazlauskas.me/entries/errors as a reference

use crate::*;

use std::io;
use std::result;
use thiserror::Error;

pub type Result<T> = result::Result<T, Error>;

/// An error that can occur in this crate.
///
/// Generally, this error corresponds to problems with underlying process.
#[non_exhaustive]
#[derive(Debug, Error)]
pub enum Error {
    // #[error("TODO")]
    // Config,
    #[error(
        "Could not achieve the \"{step}\" step. Command `{cmd}` resulted in an exited with: {source}"
    )]
    Execution {
        source: io::Error,
        step: UpdateSteps,
        cmd: ActualCmd,
    },
}
